Ushur API Documentation

Ushur is an AI-powered platform that combines process automation and conversational interfaces to automate enterprise workflows. In doing so Ushur delivers great value to those enterprises by eliminating manual work and freeing up human capital for higher valued business needs.

Ushur’s platform offers a template-based approach to solving specific use-cases for companies. The platform offers a state-of-the-art linguistics engine, together with a drag and drop process and conversation builder, invisible apps that deliver app-like experiences without asking customers to download an app and integration hooks into standard and proprietary systems of record. Along with this infrastructure, Ushur offers real-time monitoring, audit capabilities and a powerful analytics engine.

Account OPS

Sign In

This is the initial API that would take in the credentials email and password for the account and return back token id which will be used in various other API calls.

When other API fails to access the account because token id had expired, the application is expected to initiate this sign-in process again to retrieve the new token for further interactions with Ushur.

Parameter Description
email Users can log in to their account using this email identifier they originally signed-up with.
password Password for the account.
Method: POST
URL:  https://community.ushur.me/rest/login
Content-Type: application/json

{
"email":"ushurtester@gmail.com",
"password":"testushur"
}
{
  "status": "success",
  "respCode": "200",
  "tokenId": "eyJhbGciOiJIUzI1NiJ9.eyJqdGkiOiJiYmQzMjIyNy0zMTY0LTRmNGEtYmNjYy1jMzdjZTg1MjlmMzYiLCJpYXQiOjE1NTkyNzYxNDEsInN1YiI6IkFjY291bnRBdXRoIiwiaXNzIjoiVVNIVVIiLCJhY2NvdW50RW5hYmxlZCI6IlkiLCJ1c2VyQWNjb3VudCI6IkdVUlVSQUpBLktPU0lHSUBVU0hVUi5DT00iLCJleHAiOjE1NTkyODMzNDF9.m_AQBIoUPdLMqrrBZ2S7pTAnsrkDLVpAGyLif2dQR9M",
  "emailId": "ushurtester@gmail.com",
  "nickName": "test4ushur",
  "tokenLeaseTime": "120",
  "tokenRenewThreshold": "3",
   "eaAssociations": [
    {
      "bizName": "EnterpriseAccount-1"
    },
    {
      "bizName": "EnterpriseAccount-2"
    }
  ]
  
  }
{
  "status": "failure",
  "respCode": "403",
  "data": null,
  "infoText": "Account not found",
}
{
  "status": "failure",
  "respCode": "200",
  "infoText": "You are not a valid user",
  "emailId": "xxxxxxx@gmail.com"
}
Parameter Description
status A textual indication of success or failure.
respCode An integer code for programmatic purposes. 200 denotes success and 4xx denotes failure. See responseCodes tab for all codes.
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For subsequent API section.
emailId The submitted email identifier is returned back for correlation purposes. If there are multiple outstanding requests, this helps the caller of the APIs to correlate requests and responses.
nickName The Nick Name in the account is returned.
tokenLeaseTime The lease duration is time to live value: the time in seconds for which the token is valid.
tokenRenewThreshold The maximum number of times the token can be renewed.
Method: POST
URL:  https://instance.ushur.me/api/rest/accounts/login
Content-Type: application/json

{
    "email":"user@domain.com",
    "password":"userPassword"
}
{
    "tokenId": "<<GENERATED-TOKEN>>",
    "nickName": "userNickName",
    "tokenLeaseTime": "60",
    "tokenRenewThreshold": "3"
}
Parameter Description
email The email address of the user account
password The password of the user account
Parameter Description
400 If mandatory parameters are missing
401 If account credentials aren't valid
403 If user is not authorized to login
405 If unsupported HTTP method is used
200 Successful login
Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services.
nickName The Nick Name in the account is returned
tokenLeaseTime The lease duration is time to live value: the time in minutes for which the token is valid
tokenRenewThreshold The maximum number of times the generated token can be renewed

RenewToken

This is the API that would be required to renew the token which was given by system during login procedure , it takes the current exisiting token as input and returns the new token with new lease time

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally regenerate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
Method: POST
					URL:  https://community.ushur.me/rest/authtoken/renew
					Content-Type: application/json

					{
					"tokenId": "eyJhbGciOiJIUzI1NiJ9.eyJqdGkiOiJiYmQzMjIyNy0zMTY0LTRmNGEtYmNjYy1jMzdjZTg1MjlmMzYiLCJpYXQiOjE1NTkyNzYxNDEsInN1YiI6IkFjY291bnRBdXRoIiwiaXNzIjoiVVNIVVIiLCJhY2NvdW50RW5hYmxlZCI6IlkiLCJ1c2VyQWNjb3VudCI6IkdVUlVSQUpBLktPU0lHSUBVU0hVUi5DT00iLCJleHAiOjE1NTkyODMzNDF9.m_AQBIoUPdLMqrrBZ2S7pTAnsrkDLVpAGyLif2dQR9M"
					}
{
				"status": "success",
				"respCode": "200",
				"tokenId": "eyJhbGciOiJIUzI1NiJ9.eyJqdGkiOiIyYjY0MmIzYi1iYTcyLTQ2OWEtYTExNy1lZWIxOTRjZDU3N2MiLCJpYXQiOjE1NjA0MDY3NzksInN1YiI6IkFjY291bnRBdXRoIiwiaXNzIjoiVVNIVVIiLCJhY2NvdW50RW5hYmxlZCI6IlkiLCJ1c2VyQWNjb3VudCI6IlNIVUJIQURBLlBBVEhBS0BVU0hVUi5DT00iLCJleHAiOjE1NjA0MTM5Nzl9.cT14SSCdossIzMMtupVhgTAhI9Dr3oogFoTAqb4h7ck",
				"tokenLeaseTime": "120",
				"tokenRenewThreshold": "3"
  				}
{
				"status": "failure",
				"respCode": "401",
				"data": null,
				"infoText": "You are not a valid user",
				}
Parameter Description
status A textual indication of success or failure.
respCode An integer code for programmatic purposes. 200 denotes success and 4xx denotes failure. See here for all codes.
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally regenerate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
tokenLeaseTime The lease duration is time to live value: the time in seconds for which the token is valid.
tokenRenewThreshold The maximum number of times the token can be renewed.
Method: POST
URL:  https://instance.ushur.me/api/rest/accounts/tokens/refresh
Authorization: Bearer <TOKEN>

No request body
{
    "tokenId": "<<GENERATED-TOKEN>>",
    "tokenLeaseTime": "60",
    "tokenRenewThreshold": "3"
}
Parameter Description
401 If token is invalid or expired
405 If unsupported HTTP method is used
200 Successful token refresh
Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services.
tokenLeaseTime The lease duration is time to live value: the time in minutes for which the token is valid
tokenRenewThreshold The maximum number of times the generated token can be renewed

Get DoNotDisturb Status Settings

This is to retrieve the DoNotDisturb Status settings for the Ushur Account. An Account can represent an enterprise.


Parameter Description
userName This should be an email address that Users used to login to their account when they originally signed-up with.
token The credential for identifying the account. This is the token that was sent by Ushur as part of the login response.
A GET Form is shown for a login:

https://community.ushur.me/rest/doNotDisturb/getStatus?userName={{email}}&token={{token}}
{
  "status": "success",
  "respCode": 200,
  "data": {
      "dndDateStatus": "Y",
      "dndTimeStatus": "Y"
    },
    "infoText": "DND status retrieved successfully."
}
{
  "status": "failure",
  "respCode": "404",
  "data":null,
  "infoText": "Account not found",
}
Parameter Description
status A textual indication of success or failure.
respCode An integer code for programmatic purposes. 200 denotes success and 4xx denotes failure.
data A JSON Array of date status and time status. A response can be a null array when there are no DND Settings.
infoText A description of the response for the submitted request.
Method: POST
URL:  https://instance.ushur.me/api/rest/accounts/dndStatus/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userName":"user@domain.com"
}
Method: POST
URL:  https://instance.ushur.me/api/rest/accounts/dndStatus/search?userName=<user-email>
Authorization: Bearer <TOKEN>

No request body
{
    "dndDateStatus": "N",
    "dndTimeStatus": "N"
}
Parameter Description
userName This should be an email address that Users used to login to their account when they originally signed-up with.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to get data
405 If unsupported HTTP method is used
200 Successful fetch of data
Parameter Description
dndDateStatus Y if DND is set for a date, N otherwise
dndTimeStatus Y if DND is set for a time, N otherwise

Get DoNotDisturb Settings

This is to retrieve the DoNotDisturb settings for the Ushur Account. An Account can represent an enterprise.

Parameter Description
userName This should be an email address that Users used to login to their account when they originally signed-up with.
token The credential for identifying the account. This is the token that was sent by Ushur as part of the login response.
https://community.ushur.me/rest/doNotDisturb/getStatus?userName={{email}}&token={{token}}
{
  "status": "success",
  "respCode": 200,
  "data": [
    {
      "time": "20:30,6:00",
      "day": "mon,tue"
    },
    {
      "time": "22:00,6:00",
      "day": "weekends"
    }
  ],
  "infoText": "DND schedule retrieved successfully."
}
{
  "status": "failure",
  "respCode": "404",
  "data":null,
  "infoText": "Account not found",
}
Parameter Description
status A textual indication of success or failure.
respCode An integer code for programmatic purposes. 200 denotes success and 4xx denotes failure.
data A JSON Array of time and day. A response can be a null array when there are no DND Settings. The time is in 24-hour format. Day values can be weekdays, weekends, a list of days, or a single day.
infoText A description of the response for the submitted request.
Method: POST
URL:  https://instance.ushur.me/api/rest/accounts/dndSchedule/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userName":"user@domain.com"
}
Method: POST
URL:  https://instance.ushur.me/api/rest/accounts/dndSchedule/search?userName=<user-email>
Authorization: Bearer <TOKEN>

No request body
[
    {
        "date": "05-18",
        "comment": "Holiday"
    },
    {
        "date": "05-19",
        "comment": "Holiday"
    },
    {
        "date": "05-26",
        "comment": "Holiday"
    },
    {
        "time": "09:00,17:00",
        "day": "everyday"
    }
]
Parameter Description
userName This should be an email address that Users used to login to their account when they originally signed-up with.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to get data
405 If unsupported HTTP method is used
200 Successful fetch of DND schedule (a schedule is set)
204 No DND schedule is set for date or time
Parameter Description
Response body An array is returned that contains the details about the DND schedule (including date and time DND schedules).

Set DoNotDisturb Status Settings

This is to set the DoNotDisturb Status for the Ushur Account. An Account can represent an enterprise.

Parameter Description
userName Users can access their account using the email identifier they originally signed-up with.
tokenId The credential for identifying the account. This is the tokenId that was sent by Ushur as part of login response.
raw json data The JSON request body to be sent along with the API call. The JSON contains two keys: - dndTimeStatus: To update the DND Time Window. - dndDateStatus: To update the DND Holiday setting. For example, [ { "dndTimeStatus": "Y", "dndDateStatus": "Y" } ]
https://community.ushur.me/rest/doNotDisturb/setStatus?token={{tokenId}}&userName={{username}}

				Raw Json Data in POST:
				
					[
					{
						"dndTimeStatus": "Y",
						"dndDateStatus": "Y"
					}
					]
{
					  "status": "success",
					  "respCode": 200,
					  "data": null,
					  "infoText": "DND status updated successfully."
					}
Parameter Description
status A textual indication of success or failure.
respCode An integer code for programmatic purposes. 200 denotes success and 4xx denotes failure.
data No relevance today.
infoText A description of the response for the submitted request.
Method: PATCH
URL:  https://instance.ushur.me/api/rest/accounts/dndStatus
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userName": "<user-email>",
    "dndStatus": {
        "dndTimeStatus": "N",
        "dndDateStatus": "N"
    }
}
Parameter Description
dndStatus The dndStatus is a JSON object that contains two keys: - dndTimeStatus: To update the DND Time Window. - dndDateStatus: To update the DND Holiday setting. For example, dndStatus: { "dndTimeStatus": "Y", "dndDateStatus": "Y" }
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to get data
405 If unsupported HTTP method is used
204 Success in setting DND status

Set DoNotDisturb Settings

This is to set the DoNotDisturb Schedule for the Ushur Account. An Account can represent an enterprise.

Parameter Description
userName Users can access their account using the email identifier they originally signed-up with.
tokenId The credential for identifying the account. This is the tokenId that was sent by Ushur as part of login response.
raw json data The JSON body to be sent in the API call. Contains a list of JSON, each JSON contains DND scheduling info like - day: The day on which DND is to be scheduled - time: The time of the day during which DND will be active. For example, [ { "day": "mon,wed,fri", "time": "20:30,5:30" }, { "day": "weekends", "time": "22:00,5:00" } ]
https://community.ushur.me/rest/doNotDisturb/set?token={{tokenId}}&userName={{username}}

Raw Json Data in POST:
	
				[
					{
						"day": "Wednesday",
						"time": "10:00 AM",
						"date": "2019-04-10",
						"comment": "Dont want"
					}        
				]
{
						"status": "success",
						"respCode": 200,
						"data": null,
						"infoText": "DND schedule added successfully."
					}
Parameter Description
status A textual indication of success or failure.
respCode An integer code for programmatic purposes. 200 denotes success and 4xx denotes failure.
data No relevance today.
infoText A description of the response for the submitted request.
Method: PATCH
URL:  https://instance.ushur.me/api/rest/accounts/dndSchedule
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userName": "<user-email>",
    "dndSchedule": [
        { "day": "05-18", comment: "busy" },
        { "day": "mon,wed,fri", "time": "20:30,5:30" }, 
        { "day": "weekends", "time": "22:00,5:00" } 
    ]
}
Parameter Description
userName This should be an email address that Users used to login to their account when they originally signed-up with.
dndSchedule This is an array that contains a list of JSON, each JSON contains DND scheduling info like - day: The day on which DND is to be scheduled - time: The time of the day during which DND will be active. For example, [ { "day": "mon,wed,fri", "time": "20:30,5:30" }, { "day": "weekends", "time": "22:00,5:00" } , {"day": "06-10", "comment": "public holiday"}]
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to get data
405 If unsupported HTTP method is used
204 Success in setting DND schedule

Account List Query

This infoquery provides list of all the accounts in a given instance The API returns records which are present after the last record ID.

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
lastRecordId The last account ID is the record number stored in the DB. If null value is passed, it return all the records for the instance.
apiVer The version of the API being used which is by default set to 2.1 for this API.
Method : POST
		https://community.ushur.me/infoQuery/accountListQuery
		Content-Type:application/json
		{
		"cmd":"accountListQuery",
		"lastRecordId":null,
		"tokenId":"{{currentValidToken}}",
		"apiVer":"2.1"
		}
{
		{
			"accounts":[
						"10@USHURDUMMY.ME","11@USHURDUMMY.ME","1@USHURDUMMY.ME","2@USHURDUMMY.ME","7@USHURDUMMY.ME",........
						],
			"totalCount":85,
			"lastRecordId":85
		}
		}
Parameter Description
accounts The response returns the list of accounts for a specific instance.
Method: GET
URL:  https://instance.ushur.me/api/rest/accounts
Authorization: Bearer <TOKEN>
Method: GET
URL:  https://instance.ushur.me/api/rest/accounts?lastRecordId=50
Authorization: Bearer <TOKEN>
{
    "accounts": [
        "u1@domain.com",
        "u2@domain.com",
        "u3@domain.com"
    ],
    "totalCount": 3,
    "lastRecordId": 3
}
Parameter Description
lastRecordId The last account ID is the record number stored in the DB. If not passed, it returns all the records for the instance.
Parameter Description
401 If token is invalid or expired
403 If user is not authorized to get data
405 If unsupported HTTP method is used
200 Success in fetching list of accounts
204 No accounts found
Parameter Description
accounts The response returns the list of accounts for a specific instance.

Get List of Sub-Accounts

This infoquery provides a list of all the sub accounts that an admin account has. The response will be based on the filter command passed.

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response and then use for subsequent API services.
filterCmd The filter parameter that passed as input. For the specific example, Role details of the sub-accounts passed as a filter.
apiVer The version of the API being used which is by default set to 2.1 for this API.
Method : POST
		https://community.ushur.me/infoQuery/subAccountList
		Content-Type:application/json
		{
		"cmd":"subAccountList",
		"filterCmd":"getRoleInfo",
		"tokenId":"{{currentValidToken}}",
		"apiVer":"2.1"
		}
{
		{
		"accounts":[
						{
							"userName":"XXXXX@GMAIL.COM",
							"accountStatus":"active",
							"roleType":"SuperUser",
							"roleId":"SuperUser"
						},
						{
							"userName":"firstname.lastname@USHUR.COM",
							"accountStatus":"inactive",
							"roleType":"NormalUser",
							"roleId":"NormalUser"
						}
					],
		"totalCount":1,
		"lastRecordId":1
	}
	}
Parameter Description
userName The account ID which is the email ID of the sub account.
accountStatus Response returns whether the account is active or inactive.
roleType Returns whether the user is a normal user or Superuser.
roleId Returns the role Id which is based on whether the user is a normal user or SuperUser.
Method: GET
URL:  https://instance.ushur.me/api/rest/subAccounts
Authorization: Bearer <TOKEN>
Method: GET
URL:  https://instance.ushur.me/api/rest/subAccounts?filterCmd=getRoleInfo
Authorization: Bearer <TOKEN>
{
    "accounts": [
        {
            "userName": "u2@domain.com",
            "accountStatus": "active"
        }
    ],
    "totalCount": 1,
    "lastRecordId": 1
}
Parameter Description
filterCmd The filter parameter that passed as input. For the specific example, Role details of the sub-accounts passed as a filter.
Parameter Description
401 If token is invalid or expired
403 If user is not authorized to get data
405 If unsupported HTTP method is used
200 Success in fetching list of sub accounts
204 No sub accounts found
Parameter Description
userName The account ID which is the email ID of the sub account.
accountStatus Account is active or not
roleType Type of user: normal, superuser, etc.
roleId Role Id which is based on whether the user is a normal user or SuperUser.

Get User Role Information

Get RoleInfo for User( privileges).

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
userName The user name whose role details needs to be captured.
apiVer The version of the API being used which is by default set to 2.2 for this API.
Method : POST
		https://community.ushur.me/infoQuery/getUserRoleInfo
		Content-Type:application/json
		{
		"cmd":"getUserRoleInfo",
		"username":"abcd@abcd.com",
		"tokenId":"{{currentValidToken}}",
		"apiVer":"2.2"
		}
{
		{
			"userName": "abcd@abcd.COM",
			"roleType": "AdminUser",
			"roleId": "xxxxAdmin"
		}

		}
Parameter Description
userName The user name whose role details needs to be captured.
roleType returns whether the user role is Admin, Superuser, Normal or custom.
roleId The roleId that is configured for the specific username.

Set User Role Information

Setting role (privileges) for a sub useraccount. 

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
userName The user name for whom role details need to be set.
roleType set the user role as Admin, Superuser, Normal, or custom.
roleId The role that is configured for the specific username.
apiVer The version of the API being used which is by default set to 2.1 for this API.
Method : POST
		https://community.ushur.me/infoSet/setUserRoleInfo
		Content-Type:application/json
		{
			"tokenId":"{{token}}",
			"roleId":"SuperUser",
			"roleType":"SuperUser",
			"userName":"abcd@abcd.COM",
			"apiVer":"2.1"
		}
{
		200 OK
			{  
				 "status":"success",
				 "respText":"Updated role successfully"
			}
		}
Parameter Description
status Returns whether the specified privileges were set for the user or not.
respText Returns the text message on whether the specified privileges were set or not.

Get Role Information

Get RoleInfo for User( privileges).

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response and then use for subsequent API services.
userName The user name whose role details needs to be captured.
apiVer The version of the API being used which is by default set to 2.2 for this API.
Method : POST
		https://community.ushur.me/infoQuery/getUserRoleInfo
		Content-Type:application/json
		{
		"cmd":"getUserRoleInfo",
		"username":"abcd@abcd.com",
		"tokenId":"{{currentValidToken}}",
		"apiVer":"2.2"
		}
{
		{
			"userName": "abcd@abcd.COM",
			"roleType": "AdminUser",
			"roleId": "xxxxAdmin"
		}

		}
Parameter Description
userName The user name whose role details needs to be captured.
roleType returns whether the user role is Admin, Superuser, Normal, or custom.
roleId The role that is configured for the specific username.

Set Role Information

Setting role (privileges) for a sub useraccount.

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
userName The user name for whom role details need to be set.
roleType set the user role as Admin, Superuser, Normal, or custom.
roleId The role that is configured for the specific username.
apiVer The version of the API being used which is by default set to 2.1 for this API.
Method : POST
		https://community.ushur.me/infoSet/setUserRoleInfo
		Content-Type:application/json
		{
			"tokenId":"{{token}}",
			"roleId":"SuperUser",
			"roleType":"SuperUser",
			"userName":"abcd@abcd.COM",
			"apiVer":"2.1"
		}
{
		200 OK
			{  
				 "status":"success",
				 "respText":"Updated role successfully"
			}
		}
Parameter Description
status Returns whether the specified privileges were set for the user or not.
respText Returns the text message on whether the specified privileges were set or not.

Get All Roles

This API returns all the custom roles for a given user.

Parameter Description
tokenId For any API operation other than the signup, the caller is expected to pass the credential which is this token Id that is returned upon a successful login submission. This tokenId must be sent in all API requests for other services. For security reasons, Ushur has some mechanisms whereby it can internally re-generate this tokenId which is unique in the system. If an API request fails, the API caller is required to invoke the Login API, retrieve the updated tokenId from the response, and then use for subsequent API services.
apiVer The version of the API being used which is by default set to 2.1 for this API.
Method : POST
		https://community.ushur.me/infoQuery/getAllRoles
		Content-Type:application/json
		{
		"cmd":"getAllRoles",
		"tokenId":"{{currentValidToken}}",
		"apiVer":"2.1"
		}
{
			{
			   "roles":[
							   {
									 "roleId":"customrole",
									  "roleType":"AdminUser"
							   }
							],
			  "count":1
			}
		}
Parameter Description
roleId The roleId created for a specific customer role in the account.
roleType Returns the response privileges for the user.

Ushur Engagement

Initiate Any Campaign

This API is to initiate an Ushur (also called as Campaign) to a specific phone number if this is a single campaign but if a bulk campaign the Ushur will be launched to all the users in the enterprise and hence the userPhoneNo parameter will be ignored if present.

Parameter Description
cmd A mandatory parameter. This is the command to indicate the action taken on the server. Possible values are initCampaign, initBulkCampaign. initCampaign will launch the campaign indicated by the campaignId to the userPhoneNo indicated in the message. initBulkCampaign will launch the campaign to all the users in the user db associated with the enterprise indicated by the tokenId. In this case, the userPhoneNo is not needed in the API call.
campaignID A mandatory parameter. This is an identifier for an Ushur structured message that will be sent out upon this request when successfully completed. This identifier will be published to the API caller as part of the documentation process.
tokenId A mandatory parameter. The credential for identifying the account. This is the tokenId that was sent by Ushur as part of the login response.
callBackNumber An optional parameter. This is the phone number of the business that Ushur will connect the user to for a voice call.
userPhoneNo Mandatory for a single destination user and not necessary for a bulk campaign. This is the destination phone number to where this message is directed.
userMsg An optional parameter. This message will replace if there are any contents in the initial Welcome module of the campaign/Ushur being initiated. This message will be used when the initial Welcome module is empty as well.
apiVer API Version of value 2.1 or greater as the value would return a more detailed response. Recommended to be used.
sendDate An optional parameter. A scheduled send. At this UTC (Coordinated Universal Time) date the Ushur will be initiated. This scheduling happens regardless of the type of cmd. For example, a bulk campaign will be scheduled when this parameter is sent.
userTimezone An optional field. This field can be utilized to specify the timezone to be used for DND calculation.
userEmailId An optional parameter used to mention the email id to which an email is to be initiated.
expiry An optional parameter. A JSON containing the engagement expiry deadline time specified by the number of days, hours, and minutes and a message that is to be displayed after the engagement is expired.
AppContext The application context under which the ushur that you want to trigger is located.
content A list of contents, in JSON format, that you wish to immediately add as meta data (i.e. add under Metadata tab).
variables It should contain the values of campaign variables along with the keys in json format which will be used in the engagement.
launchParams An optional parameter. A JSON containing the launch information such as launchMode, launchTime, launchSource, launchIdentifier, launchByUserEmail, launchByUserId
Method: POST
URL: https://community.ushur.me/initUshur
Content-Type: application/json

{
"cmd": "initCampaign",
"tokenId": "{{token}}",
"userPhoneNo": "+16614187487",
"userEmailId": "ushurtest@gmail.com",
"campaignId": "NetPromoterScore",
"userMsg": "Welcome",
"apiVer":"2.1",
"userTimezone": "EST",
"expiry": {
        "days": 0,
        "hours": 0,
        "minutes": 1,
        "message": "The engagement expired."
  }
}
Method: POST
URL: https://community.ushur.me/initUshur
Content-Type: application/json

{
"cmd": "initBulkCampaign",
"tokenId": "{{demotokenid}}",
"campaignId": "NotifyWithIALink",
"groupId":"GroupA",
"apiVer":"3.1",
"sendDate": "2020-09-24T22:35:00.000Z"
}
Method: POST
URL: https://community.ushur.me/initUshur
Content-Type: application/json

{
"tokenId":"{{tokenID}}",
"cmd":"initCampaign",
"userPhoneNo":"+16614187487",
"campaignId":"assetDownload",
"apiVer":"3.1",
"requestId":"001",
"AppContext":"Main",
"content":[
  {
 	"e_nameDataNotation":"Initiate Ushur",
 	"e_idDataNotation":"1"
  }
 ]
}
Method: POST
URL: https://community.ushur.me/initUshur
Content-Type: application/json

{
"cmd": "initCampaign",
"tokenId": "{{token}}",
"userPhoneNo": "+16614187487",
"userEmailId": "ushurtest@gmail.com",
"campaignId": "NetPromoterScore",
"userMsg": "Welcome",
"apiVer":"2.1",
"userTimezone": "EST",
"expiry": {
        "days": 0,
        "hours": 0,
        "minutes": 1,
        "message": "The engagement expired."
  },
 "variables": {
         "name":"Ushur",
         "number":3,
         "date":"11/11/21"
  }
}
Method: POST
URL: https://community.ushur.me/initUshur
Content-Type: application/json

{
"cmd": "initCampaign",
"tokenId": "{{token}}",
"userPhoneNo": "+16614187487",
"userEmailId": "ushurtest@gmail.com",
"campaignId": "NetPromoterScore",
"userMsg": "Welcome",
"apiVer":"2.1",
"userTimezone": "EST",
"expiry": {
        "days": 0,
        "hours": 0,
        "minutes": 1,
        "message": "The engagement expired."
  },
  "launchParams": {
    "launchMode": "IP_PUSH",
    "launchSource": "InvisiblePortal",
    "launchIdentifier": "1690b066-e4cc-45b3-a1b6-1fb5b7ac6db6"
  }
}
{
      "status": "success",
      "respCode": 200,
      "respText": "Success",
      "activityId": "ffe96950-140a-445c-834c-dcc3b22017cb-1493284061475"
     }
{
			"status": "failure",
			"respCode": "404",
			"respText": "Invalid Ushur Id",
		 }
Parameter Description
status A textual indication of success or failure.
respCode The response code which is 200 for success.
respText A textual description of the response.
activityId The activity identifier reflects the activity pertaining to the initiated request. This can be used in other APIs to track and operate (say even cancel) on the ongoing activity.
var initSessionEndpoint = 'https://community.ushur.me/initUshur'
var jsonStringLogin = convertTOjsonData(menuId, username, callbacknum, usernum, message);

$.ajax({
    type: 'POST',
    contentType: 'application/json',
    url: initSessionEndpoint,
    dataType: "text",
    data: jsonStringLogin,
    success: function(response) {
        callbackvalue(response);
        console.log("Successfully delivered message")
    },
    error: function(jqXHR, textStatus, errorThrown) {
        console.log("Message Delivery Error:", textStatus)
    }
});

var convertTOjsonData = function(menuId, username, callbacknum, usernum, message) {
    return JSON.stringify({
        "cmd": "initCampaign",
        "callBackNumber": callbacknum,
        "tokenId": tokenId,
        "userPhoneNo": usernum,
        "userMsg": message,
        "campaignId": menuId
    });
};
curl -H "Content-Type: application/json; charset=UTF-8" --data @push.json https://community.ushur.me/initUshur


push.json:
{"cmd":"initCampaign",callBackNumber":"12092078446",
"tokenId":"d5dbab0d-1251-4a2f-b5eb-8c0f752e997b",
"userPhoneNo":"12098746734","userMsg":"Hi Test, 
This is a reminder for your upcoming appointment on 10/31/2014 at 1:00 PM.","campaignId":"UshurIssEnterpriseMenu"}
try {
      JSONObject json = new JSONObject();
      json.put("cmd": "initCampaign");
      json.put("callBackNumber", "12092078446");   
      json.put("tokenId", "d5dbab0d-1251-4a2f-b5eb-8c0f752e997b");  
      json.put("userPhoneNo","12098746734");
      json.put("userMsg","Hi Test, This is a reminder for your upcoming appointment on 10/31/2014 at 1:00 PM.");
      json.put("campaignId","UshurIssEnterpriseMenu");   

      CloseableHttpClient httpClient = HttpClientBuilder.create().build();

      try {
        HttpPost request = new HttpPost("https://community.ushur.me/initUshur");
        StringEntity jsonParams = new StringEntity(json.toString());
        request.addHeader("Content-type", "application/json");
        request.addHeader("Accept","application/json");
        request.setEntity(jsonParams);
        CloseableHttpResponse response = httpClient.execute(request);
        System.out.println(response.toString());
      } 
      catch (Exception ex) {
        // handle exception here
      } 
      finally {
        httpClient.close();
      }
} 

catch (Exception e) {
    e.printStackTrace();
}
HTTP/1.1 200 OK [Date: Thu, 23 Oct 2014 03:30:01 GMT, Content-Type: text/html;charset=ISO-8859-1, Content-Length: 7, Server: naju server 2.51]


A negative (non-200) HTTP response will indicate that the send message failed.
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/<USHUR_NAME>/launch
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userPhoneNo": "+16614187487",
    "userEmailId": "ushurtest@gmail.com",
    "userTimezone": "EST",
    "expiry": {
        "days": 0,
        "hours": 0,
        "minutes": 1,
        "message": "The engagement expired."
    }
}
{
    "activityId": "e0c1a8e9-dc99-446a-8c36-a1beae3bf0db-1620970950043"
}
Parameter Description
USHUR_NAME Name of the ushur to launch
callBackNumber An optional parameter. This is the phone number of the business that Ushur will connect the user to for a voice call.
userPhoneNo Mandatory for a single destination user and not necessary for a bulk campaign. This is the destination phone number to where this message is directed.
userMsg An optional parameter. This message will replace if there are any contents in the initial Welcome module of the campaign/Ushur being initiated. This message will be used when the initial Welcome module is empty as well.
userTimezone An optional field. This field can be utilized to specify the timezone to be used for DND calculation.
userEmailId An optional parameter used to mention the email id to which an email is to be initiated.
expiry An optional parameter. A JSON containing the engagement expiry deadline time specified by the number of days, hours, and minutes and a message that is to be displayed after the engagement is expired.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to launch campaigns
405 If unsupported HTTP method is used
202 Successfully launched campaign
Parameter Description
activityId The activity identifier reflects the activity pertaining to the initiated request. This can be used in other APIs to track and operate (say even cancel) on the ongoing activity.

Schedule Any Campaign

This API is to schedule an Ushur (also called as Campaign) to a specific phone number if this is a single campaign but if a bulk campaign the Ushur will be launched to all the users in the enterprise and hence the userPhoneNo parameter will be ignored if present.

Method: POST
URL: https://instances.ushur.me/ushurs/<USHUR_NAME>/schedule
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userPhoneNo": "+16614187487",
    "userEmailId": "ushurtest@gmail.com",
    "userTimezone": "EST",
    "sendDate": "2021-05-14T05:56:00.336Z",
    "expiry": {
        "days": 0,
        "hours": 0,
        "minutes": 1,
        "message": "The engagement expired."
    }
}
{
    "activityId": "e0c1a8e9-dc99-446a-8c36-a1beae3bf0db-1620970950043"
}
Parameter Description
callBackNumber An optional parameter. This is the phone number of the business that Ushur will connect the user to for a voice call.
userPhoneNo Mandatory for a single destination user and not necessary for a bulk campaign. This is the destination phone number to where this message is directed.
userMsg An optional parameter. This message will replace if there are any contents in the initial Welcome module of the campaign/Ushur being initiated. This message will be used when the initial Welcome module is empty as well.
sendDate A mandatory parameter. A scheduled send. At this UTC (Coordinated Universal Time) date the Ushur will be initiated. This scheduling happens regardless of the type of cmd. For example, a bulk campaign will be scheduled when this parameter is sent.
userTimezone An optional field. This field can be utilized to specify the timezone to be used for DND calculation.
userEmailId An optional parameter used to mention the email id to which an email is to be initiated.
expiry An optional parameter. A JSON containing the engagement expiry deadline time specified by the number of days, hours, and minutes and a message that is to be displayed after the engagement is expired.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to schedule campaigns
405 If unsupported HTTP method is used
202 Successfully scheduled campaign
Parameter Description
activityId The activity identifier reflects the activity pertaining to the initiated request. This can be used in other APIs to track and operate (say even cancel) on the ongoing activity.

Notify a Message

This API is to notify a message via an Ushur (also called as Campaign) to a specific phone number if this is a single campaign but if a bulk campaign the Ushur (hence the message) will be launched to all the users in the enterprise and hence the userPhoneNo parameter will be ignored if present.

Parameter Description
cmd A mandatory parameter. This is the command to indicate the action taken on the server. Possible values are initCampaign, initBulkCampaign. initCampaign will launch the campaign indicated by the campaignId to the userPhoneNo indicated in the message. initBulkCampaign will launch the campaign to all the users in the user db associated with the enterprise indicated by the tokenId. In this case, the userPhoneNo is not needed in the API call.
campaignId A mandatory parameter. This is an identifier for an Ushur structured message that will be sent out upon this request when successfully completed. This identifier will be published to the API caller as part of the documentation process. Although this can be any Ushur that has an (empty or not) welcome and this message in the API will go to a mobile phone number, if the need is to just send a message then existing template NotifyMsg Ushur can be used.
tokenId A mandatory parameter. The credential for identifying the account. This is the tokenId that was sent by Ushur as part of the login response.
userPhoneNo Mandatory for a single destination user and not necessary for a bulk campaign. This is the destination phone number to where this message is directed.
userMsg An optional parameter. This message will replace if there are any contents in the initial Welcome module of the campaign/Ushur being initiated. This message will be used when the initial Welcome module is empty as well.
apiVer API Version of value 2.1 or greater as the value would return a more detailed response. Recommended to be used.
Method: POST
URL: https://community.ushur.me/initUshur
Content-Type: application/json

{
"cmd": "initCampaign",
"tokenId": "{{acmetokenid}}",
"userPhoneNo": "+16614187487",
"campaignId": "NotifyMsg",
"userMsg":"Hello World! This is Ushur!",
"apiVer":"2.1"
}
{
  "status": "success",
  "respCode": 200,
  "respText": "Success",
  "activityId": "0792c664-df05-47d0-9032-eb5e1c4ccaa5-1493285425824"
}
Parameter Description
status A textual indication of success or failure.
respCode The response code, which is 200 for success.
respText A textual description of the response.
activityId The activity identifier, that reflects the activity pertaining to the initiated request. This can be used in other APIs to track and operate (say even cancel) on the ongoing activity.
Method: POST
URL: https://instance.ushur.me/api/rest/sendSMSMessage
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userPhoneNo": "+16614187487",
    "text": "This is the notify message"
}
Parameter Description
userPhoneNo A mandatory parameter. This is the number to which text would be sent.
text A mandatory parameter. This is the text to be sent to the phone number.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to launch campaigns
405 If unsupported HTTP method is used
202 Successfully submitted request to send text

Initiate Campaign With a Request Id

This API is similar to the previous Initiate Campaign but here the remote system sends a requestId which is a unique id in the remote system and hence treated as such in Ushur as well. For example, the requestId can be an incident Id of the remote system or a concatenation of multiple identities such as an AccountId:CustomerId wherein a specific customer can be in different accounts with the enterprise. With the requestId the Ushur platform can retrieve enterprise records that have this requestId value as the unique key.

Parameter Description
cmd This is the command to indicate the action taken on the server. Possible values are initCampaign, initBulkCampaign. initCampaign will launch the campaign indicated by the campaignId to the userPhoneNo indicated in the message. initBulkCampaign will launch the campaign to all the users in the user db associated with the enterprise indicated by the tokenId. In this case, the userPhoneNo is not needed in the API call.
requestId This is a unique request identifier from the enterprise system. An incident id from a remote service management system is an example.
campaignId This identifies the Ushur that will be sent out upon this request when successfully completed.
tokenId The credential for identifying the account. This is the tokenId that was sent by Ushur as part of the login response.
callBackNumber This is the phone number of the business that Ushur will connect the user to for a voice call.
userPhoneNo This is the destination phone number to where this message is directed.
userMsg This is the message that is sent by the remote caller entity. Ushur, if necessary will append the structured information indicated by the campaignId to this message and then forward it to the user indicated by the UserPhoneNumber.
userTimezone An optional field. This field can be utilized to specify the timezone to be used for DND calculation.
userEmailId An optional parameter used to mention the email id to which an email is to be initiated.
expiry An optional parameter. A JSON containing the engagement expiry deadline time specified by the number of days, hours, and minutes and a message that is to be displayed after the engagement is expired.
Method: POST
					URL:  https://community.ushur.me/initUshur
					Content-Type: application/json

					{
					"cmd": "initCampaign",
					"requestId" : "INC700001",
					"callBackNumber": "12092078446",
					"tokenId": "{{token}}",
					"userPhoneNo": "12098746734",
					"userEmailId": "ushurtest@gmail.com",
					"userMsg": "my domain has issues in setup",
					"campaignId": "ResConfV2_Ushur",
					"userTimezone": "EST",
					"expiry": {
					        "days": 0,
					        "hours": 0,
					        "minutes": 1,
					        "message": "The engagement expired."
					  }
					}
{
			"status": "success",
			"respCode": 200,
			"respText": "Success",
			"activityId": "0792c664-df05-47d0-9032-eb5e1c4ccaa5-1493285425824",
                        "userTimezone": "EST"
			}
Parameter Description
status A textual indication of success or failure.
respCode The response code, which is 200 for success.
respText A textual description of the response.
activityId The activity identifier, that reflects the activity pertaining to the initiated request. This can be used in other APIs to track and operate (say even cancel) on the ongoing activity.
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/<USHUR_NAME>/launch
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "userPhoneNo": "+16614187487",
    "userEmailId": "ushurtest@gmail.com",
    "userTimezone": "EST",
    "requestId": "REQ-ID-00001",
    "expiry": {
        "days": 0,
        "hours": 0,
        "minutes": 1,
        "message": "The engagement expired."
    }
}
{
    "activityId": "e0c1a8e9-dc99-446a-8c36-a1beae3bf0db-1620970950043"
}
Parameter Description
USHUR_NAME Name of the ushur to launch
callBackNumber An optional parameter. This is the phone number of the business that Ushur will connect the user to for a voice call.
userPhoneNo Mandatory for a single destination user and not necessary for a bulk campaign. This is the destination phone number to where this message is directed.
requestId This is a unique request identifier from the enterprise system. An incident id from a remote service management system is an example.
userMsg This is the message that is sent by the remote caller entity. Ushur, if necessary will append the structured information indicated by the campaignId to this message and then forward it to the user indicated by the UserPhoneNumber.
userTimezone An optional field. This field can be utilized to specify the timezone to be used for DND calculation.
userEmailId An optional parameter used to mention the email id to which an email is to be initiated.
expiry An optional parameter. A JSON containing the engagement expiry deadline time specified by the number of days, hours, and minutes and a message that is to be displayed after the engagement is expired.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to launch campaigns
405 If unsupported HTTP method is used
202 Successfully launched campaign
Parameter Description
activityId The activity identifier reflects the activity pertaining to the initiated request. This can be used in other APIs to track and operate (say even cancel) on the ongoing activity.

Get Detailed Responses For a Request Id

This is a query API to retrieve detailed responses on the initiation of campaigns using the requestId.

Parameter Description
tokenId The credential for identifying the account. This is the tokenId that was sent by Ushur as part of the login response.
cmd responseForReqId is the command that needs to be passed for this.
requestId The request identifier for which responses are being retrieved.
campaignId This is the Ushur that was initiated for which responses are being requested here.
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId" :"INC700001",
"tokenId":"{{token}}",
"campaignId":"ResConfV2_Ushur"
}
{
  "stats": {
    "optId_1": 1,
    "menu.sent": 2,
    "menu.resp": 1
  },
  "result": [
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 19:58:49 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 19:58:49 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur",
        "campaignId": "ResConfV2_Ushur",
        "visual": "false",
        "type": "menu.disabled.sent",
        "dispStr": "Message Sent",
        "content": "[entspdev]:my domain has issues in setup"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 19:58:49 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 19:58:49 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_91a8b4d9-d614-47fd-8666-2ce5935470a1",
        "campaignId": "ResConfV2_Ushur",
        "visual": "false",
        "type": "menu.sent",
        "dispStr": "Menu Sent",
        "meta": {
          "topic": "Is your issue resolved now?\nPlease respond with a number",
          "menuOptions": {
            "1": "Yes",
            "2": "No"
          }
        }
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:01:09 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:01:09 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_91a8b4d9-d614-47fd-8666-2ce5935470a1",
        "campaignId": "ResConfV2_Ushur",
        "type": "menu.response",
        "optionId": "1",
        "dispStr": "Yes"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:01:09 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:01:09 EST 2016",
      "location": "",
      "response": {
        "visual": "false",
        "type": "menu.disabled.sent",
        "dispStr": "Message Sent"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:01:09 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:01:09 EST 2016",
      "location": "",
      "response": {
        "visual": "false",
        "type": "menu.disabled.sent",
        "dispStr": "Message Sent"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:01:09 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:01:09 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_5a68999d-130c-46d1-bef7-1303223bc64f",
        "campaignId": "ResConfV2_Ushur",
        "visual": "false",
        "type": "menu.prompt",
        "dispStr": "Prompt Sent",
        "meta": {
          "topic": "How satisfied were you with the service provided by EntSpDev on a scale from 10 (completely) to 1 (not at all)?"
        }
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:02:30 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:02:30 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_5a68999d-130c-46d1-bef7-1303223bc64f",
        "campaignId": "ResConfV2_Ushur",
        "type": "routine.response",
        "dispStr": "9"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:02:30 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:02:30 EST 2016",
      "location": "",
      "response": {
        "visual": "false",
        "type": "menu.disabled.sent",
        "dispStr": "Message Sent"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:02:30 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:02:30 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_bcff8ac7-df09-431d-8435-ff55ecaa7dc2",
        "campaignId": "ResConfV2_Ushur",
        "visual": "false",
        "type": "menu.prompt",
        "dispStr": "Prompt Sent",
        "meta": {
          "topic": "How likely are you to recommend EntSpDev products to a friend on a scale from 10 (definitely) to 1 (definitely not)?"
        }
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:02:43 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:02:43 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_bcff8ac7-df09-431d-8435-ff55ecaa7dc2",
        "campaignId": "ResConfV2_Ushur",
        "type": "routine.response",
        "dispStr": "8"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:02:43 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:02:43 EST 2016",
      "location": "",
      "response": {
        "visual": "false",
        "type": "menu.disabled.sent",
        "dispStr": "Message Sent"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:02:43 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:02:43 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_c5323bd2-bcc9-47fd-88a7-7d4622b41bfa",
        "campaignId": "ResConfV2_Ushur",
        "visual": "false",
        "type": "menu.prompt",
        "dispStr": "Prompt Sent",
        "meta": {
          "topic": "Please share any additional comments that can help us serve you better :"
        }
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:03:59 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:03:59 EST 2016",
      "location": "",
      "response": {
        "menuId": "ResConfV2_Ushur_child_section_c5323bd2-bcc9-47fd-88a7-7d4622b41bfa",
        "campaignId": "ResConfV2_Ushur",
        "type": "routine.response",
        "dispStr": "thank you for your service"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:03:59 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:03:59 EST 2016",
      "location": "",
      "response": {
        "visual": "false",
        "type": "menu.disabled.sent",
        "dispStr": "Message Sent"
      },
      "requestId": "INC700001"
    },
    {
      "name": "",
      "phone": "+12098746734",
      "date": "Thu Feb 25 20:03:59 EST 2016",
      "sid": "45fbb019-627e-40e5-88b4-7217577e25f0-uxidxyz-c69d812f-d360-42a9-8775-eab16e440dde",
      "timestamp": "Thu Feb 25 20:03:59 EST 2016",
      "location": "",
      "response": {
        "menuId": "**ENDCAMPAIGN**",
        "campaignId": "",
        "visual": "false",
        "type": "menu.sent",
        "dispStr": "Menu Sent",
        "meta": {
          "menuOptions": {}
        }
      },
      "requestId": "INC700001"
    }
  ]
}
Parameter Description
name The name of the party to whom the message was sent out and from whom this response is coming from.
phone The phone number of the party to whom the message was sent out and from where this response is coming from.
date This is the time at which the message was sent or the response received.
sid This is the identifier for correlating the responses with every message that was sent out.
timestamp This is the time at which this response arrived.
location This is the location information.
response The actual response text from the remote party to whom the message was sent out. The data also includes the id of the menu, campaignId, visual, the type of menu, display string, and actual content of the response.
requestId The request identifier for which responses are being retrieved.
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/<USHUR_NAME>/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID"
}
{
    "stats": {
        "menu.sent": 0,
        "menu.resp": 0
    },
    "result": [
        {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-14T06:24:21.301Z",
            "sid": "b564ec7d-43c6-4a58-a681-c04b48932f85-uxidxyz-f1a58b22-c220-4a23-b882-2c4eb10b5527",
            "timestamp": "2021-05-14T06:24:21.300Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "menu.disabled.sent",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "origUserMsg": "[]:null",
                "UeTagStart": "UeTag_Start",
                "sentOut": "no",
                "delivered": "false",
                "delStatus": "ToBeSentOut",
                "virtualNo": "12762402315"
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-14T06:24:21.335Z",
            "sid": "b564ec7d-43c6-4a58-a681-c04b48932f85-uxidxyz-f1a58b22-c220-4a23-b882-2c4eb10b5527",
            "timestamp": "2021-05-14T06:24:21.334Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_section_8335106c-59ab-4951-a1cd-c8b29c063f99",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "menu.disabled.sent",
                "UeTag": "UeTag_887451",
                "dispStr": "Message Sent",
                "assetId": "",
                "content": "message1 null",
                "sentOut": "yes",
                "delivered": "true",
                "delStatus": "delivered",
                "moduleType": "promptmessage"
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-14T06:24:21.364Z",
            "sid": "b564ec7d-43c6-4a58-a681-c04b48932f85-uxidxyz-f1a58b22-c220-4a23-b882-2c4eb10b5527",
            "timestamp": "2021-05-14T06:24:21.357Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_section_e4306a9a-19aa-426a-89b8-1d9ac4b1ea07",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "menu.disabled.sent",
                "UeTag": "UeTag_308171",
                "dispStr": "Message Sent",
                "assetId": "",
                "content": "Thanks!",
                "sentOut": "yes",
                "delivered": "true",
                "delStatus": "delivered",
                "moduleType": "thankyou"
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-14T06:24:21.383Z",
            "sid": "b564ec7d-43c6-4a58-a681-c04b48932f85-uxidxyz-f1a58b22-c220-4a23-b882-2c4eb10b5527",
            "timestamp": "2021-05-14T06:24:21.373Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_**ENDCAMPAIGN**",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "ushur.end",
                "UeTag": "UeTag_Primary_End",
                "dispStr": "EndOfWorkflow",
                "meta": {
                    "menuOptions": {}
                }
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-14T06:24:21.389Z",
            "sid": "b564ec7d-43c6-4a58-a681-c04b48932f85-uxidxyz-f1a58b22-c220-4a23-b882-2c4eb10b5527",
            "timestamp": "2021-05-14T06:24:21.389Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_**ENDCAMPAIGN**",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "ushur.end",
                "UeTag": "UeTag_End",
                "dispStr": "EndOfUshur",
                "meta": {
                    "menuOptions": {}
                }
            },
            "requestId": "TEST_REQUEST_ID"
        }
    ],
    "counts": 5,
    "totalRecords": 5
}
Parameter Description
USHUR_NAME This is the Ushur that was initiated for which responses are being requested here.
requestId The request identifier for which responses are being retrieved.
inLastMinutes An optional parameter. This fetches records in last N minutes.
lastRecordId This has the value of the last record that was returned in the previous responses. Having this will make the server send out records only after this record id.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to retrieve data
405 If unsupported HTTP method is used
202 Successfully retrieved all the responses
206 Successfully retrieved a batch of the responses
204 No responses found
Parameter Description
name The name of the party to whom the message was sent out and from whom this response is coming from.
phone The phone number of the party to whom the message was sent out and from where this response is coming from.
date This is the time at which the message was sent or the response received.
sid This is the identifier for correlating the responses with every message that was sent out.
timestamp This is the time at which this response arrived.
location This is the location information.
response The actual response text from the remote party to whom the message was sent out. The data also includes the id of the menu, campaignId, visual, the type of menu, display string, and actual content of the response.
requestId The request identifier for which responses are being retrieved.

Get Tagged Responses For a Request Id

Instead of getting all the detailed information as part of the query, here we get the responses for specific tags which implies responses on specific micro-engagement.

Parameter Description
tokenId The credential for identifying the account. This is the tokenId that was sent by Ushur as part of the login response.
cmd responseForReqId is the command that needs to be passed for this.
requestId The request identifier for which responses are being retrieved.
campaignId This is the Ushur that was initiated for which responses are being requested here.
UeTag This is the Ushur Micro-Engagement Tag for which a specific response is given back. These tags are campaign-specific and are expected to be known by the requestor who is aware of the campaign and the tags associated. Some of the tags for a Resolution Confirmation are, : UeTag_StatusCheck, UeTag_RecommendationRating, UeTag_SatisfactionRating, UeTag_FeedbackComment" There can be one or more tag for this parameter according to which responses are given.
lastRecordId This has the value of the last record that was returned in the previous responses. Having this will make the server send out records only after this record id.
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC700001",
"tokenId":"{{token}}",
"campaignId":"ResConfV2_Ushur",
"UeTag" : "UeTag_StatusCheck,UeTag_RecommendationRating,UeTag_SatisfactionRating,UeTag_FeedbackComment"
}
Parameter Description
Method: POST URL: https://community.ushur.me/infoQuery Content-Type: application/json { "cmd":"responseForReqId", "requestId":"INC700001", "tokenId":"{{token}}", "campaignId":"ResConfV2_Ushur", "UeTag" : "UeTag_FeedbackComment" }
Parameter Description
name The name of the party to whom the message was sent out and from whom this response is coming from.
phone The phone number of the party to whom the message was sent out and from where this response is coming from.
timestamp This is the time at which this response arrived.
response The actual response text from the remote party to whom the message was sent out. The data also includes UeTag, display string, topic information
requestId The request identifier for which responses are being retrieved.
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/<USHUR_NAME>/uetags/<UE_TAGS>/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID"
}
{
    "result": [
        {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-15T00:02:52.631Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID"
        }
    ],
    "counts": 1,
    "totalRecords": 1,
    "lastRecordId": "609f0facbd8c2573a6d9225c"
}
Parameter Description
USHUR_NAME This is the Ushur that was initiated for which responses are being requested here.
UE_TAGS This is the Ushur Micro-Engagement Tag for which a specific response is given back. These tags are campaign-specific and are expected to be known by the requestor who is aware of the campaign and the tags associated. Example: UeTag_123456,UeTag_654321.
requestId The request identifier for which responses are being retrieved.
lastRecordId This has the value of the last record that was returned in the previous responses. Having this will make the server send out records only after this record id.
Parameter Description
400 If mandatory parameters are missing
401 If token is invalid or expired
403 If user is not authorized to retrieve data
405 If unsupported HTTP method is used
200 Successfully retrieved all responses
206 Successfully retrieved a batch of responses
204 No responses found
Parameter Description
name The name of the party to whom the message was sent out and from whom this response is coming from.
phone The phone number of the party to whom the message was sent out and from where this response is coming from.
timestamp This is the time at which this response arrived.
response The actual response text from the remote party to whom the message was sent out. The data also includes UeTag, display string, topic information
requestId The request identifier for which responses are being retrieved.

Query Filters

This request enables an additional set of parameters to be introduced so as to act as filters in the response that usually contains a lot of information. One example is, if an application is only interested in the number of counts and not the actual contents then a specific filter parameter can be sent in the request, and responses are sent accordingly. Multiple query parameters can be combined.

Parameter Description
filterCmd This can contain a single or a list of commands executing on top of the actual query. The currently supported filter commands are: getSids,getCounts,LastEngagement,LastFirst,getRecordIds getSids: Displays along with other parameters the actual session identifier so that when there are multiple responses for the query, the client of this API can gather together sets of responses based on the session identifier (sid). getCounts: Currently this command will exclusively only return the counts for each of the UeTag but the counts are for the final responses based on the query. For example, LastEngagement might return a few sets and the getCounts is on this result. LastEngagement: In cases when a single query can result in multiple engagements and the application needs only the last then we use this filter. Look at the response samples below where the getSids yielded two different sessions and with LastEngagement only the latest engagement is returned. LastFirst: For the resulting query responses, this one will return in the reverse chronological order which is the last occurred will come first and the first occurred will be at the last. getRecordIds: Queries typically returns multiple records of one or more engagements. The "sid" parameter itself identifies an engagement and hence will be the same for all records within that engagement. In some cases, the remote client needs a unique identifier for each of the records across the engagements itself. Sending this parameter as part of the filterCmd will send an identifier that will be globally unique in the namespace belonging to the corresponding query. The parameter that gets sent in the response is ushurRecordId.
delivered Values are true or false. This filter is to retrieve entries where the Ue were delivered or not. This hence applies only to outgoing Ue and hence corresponding messages. If there is no delivered status then those entries will not be returned. Only those that are explicitly marked as true or false will be returned as per the query. true:Return entries that indicate the Ue was successfully delivered. false:Return entries that indicate the Ue was not delivered.
deliveryStatus Specific values indicating the nature of the delivery. Most common values are delivered, undelivered, and sent. This filter is to retrieve entries with specific delivery status regardless of the outcome of the delivery. In most cases this parameter should go without the delivered else there could be conflict and hence return null values. delivered:Return entries that indicate the Ue was successfully delivered. undelivered:Return entries that indicate the Ue was not delivered. sent:An upstream carrier has confirmed the receipt of the message.
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getSids",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
{
  "result": [
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:44:12.156Z",
      "response": {
        "UeTag": "UeTag_927455",
        "dispStr": "Menu Sent",
        "topic": "Has your issue been resolved?\nPlease respond with a number"
      },
      "requestId": "INC0010117",
      "sid": "4db06b91-1ed0-43a9-af8d-c7d822082d9f-uxidxyz-35457f74-0f4d-490a-9990-5fe4bd44b89a"
    },
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:44:28.581Z",
      "response": {
        "optionId": "2",
        "UeTag": "UeTag_881809",
        "dispStr": "No"
      },
      "requestId": "INC0010117",
      "sid": "4db06b91-1ed0-43a9-af8d-c7d822082d9f-uxidxyz-35457f74-0f4d-490a-9990-5fe4bd44b89a"
    },
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:44:28.619Z",
      "response": {
        "dispStr": "Prompt Sent",
        "UeTag": "UeTag_847034",
        "topic": "Sorry to hear that.  Please enter your comments as to why it is unresolved."
      },
      "requestId": "INC0010117",
      "sid": "4db06b91-1ed0-43a9-af8d-c7d822082d9f-uxidxyz-35457f74-0f4d-490a-9990-5fe4bd44b89a"
    },
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:45:11.743Z",
      "response": {
        "UeTag": "UeTag_927455",
        "dispStr": "Menu Sent",
        "topic": "Has your issue been resolved?\nPlease respond with a number"
      },
      "requestId": "INC0010117",
      "sid": "619764ad-83c6-4fd1-b07b-7ce5131cb6dc-uxidxyz-76e2d72c-2ee1-46fa-a10e-1b3fb7b6e855"
    }
  ],
  "counts": 4,
  "lastRecordId": "5727f497e9513852305bb48a"
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getCounts,getSids",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
{
  "UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End",
  "UeTag_847034": "1",
  "UeTag_881809": "1",
  "UeTag_927455": "2",
  "UeTag_382867": "0",
  "UeTag_253937": "0",
  "UeTag_457543": "0",
  "UeTag_635124": "0",
  "UeTag_End": "0",
  "counts": 4
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getSids,LastEngagement",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
{
  "result": [
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:45:11.743Z",
      "response": {
        "UeTag": "UeTag_927455",
        "dispStr": "Menu Sent",
        "topic": "Has your issue been resolved?\nPlease respond with a number"
      },
      "requestId": "INC0010117",
      "sid": "619764ad-83c6-4fd1-b07b-7ce5131cb6dc-uxidxyz-76e2d72c-2ee1-46fa-a10e-1b3fb7b6e855"
    }
  ],
  "counts": 1,
  "lastRecordId": "5727f497e9513852305bb48a"
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getSids,LastFirst",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
{
  "result": [
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:45:11.743Z",
      "response": {
        "UeTag": "UeTag_927455",
        "dispStr": "Menu Sent",
        "topic": "Has your issue been resolved?\nPlease respond with a number"
      },
      "requestId": "INC0010117",
      "sid": "619764ad-83c6-4fd1-b07b-7ce5131cb6dc-uxidxyz-76e2d72c-2ee1-46fa-a10e-1b3fb7b6e855"
    },
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:44:28.619Z",
      "response": {
        "dispStr": "Prompt Sent",
        "UeTag": "UeTag_847034",
        "topic": "Sorry to hear that.  Please enter your comments as to why it is unresolved."
      },
      "requestId": "INC0010117",
      "sid": "4db06b91-1ed0-43a9-af8d-c7d822082d9f-uxidxyz-35457f74-0f4d-490a-9990-5fe4bd44b89a"
    },
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:44:28.581Z",
      "response": {
        "optionId": "2",
        "UeTag": "UeTag_881809",
        "dispStr": "No"
      },
      "requestId": "INC0010117",
      "sid": "4db06b91-1ed0-43a9-af8d-c7d822082d9f-uxidxyz-35457f74-0f4d-490a-9990-5fe4bd44b89a"
    },
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-05-03T00:44:12.156Z",
      "response": {
        "UeTag": "UeTag_927455",
        "dispStr": "Menu Sent",
        "topic": "Has your issue been resolved?\nPlease respond with a number"
      },
      "requestId": "INC0010117",
      "sid": "4db06b91-1ed0-43a9-af8d-c7d822082d9f-uxidxyz-35457f74-0f4d-490a-9990-5fe4bd44b89a"
    }
  ],
  "counts": 4,
  "lastRecordId": "5727f45ce9513852305bb486"
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getCounts,getSids",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getSids,LastFirst,getRecordIds",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"requestId":"INC0010117",
"filterCmd":"getSids,LastFirst,getRecordIds",
"tokenId":"{{ven1177token}}",
"campaignId": "UshurResolutionConfirmation",
"UeTag": "UeTag_927455,UeTag_881809,UeTag_382867,UeTag_253937,UeTag_457543,UeTag_635124,UeTag_847034,UeTag_End"
}
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"cmd":"responseForReqId",
"tokenId":"{{ven1177token}}",
"requestId": "INC0010433",
"campaignId":"UshurResolutionConfirmation",
"UeTag":"UeTag_927455",
"delivered":true
}
{
  "result": [
    {
      "name": "",
      "phone": "+16614187487",
      "date": "2016-09-26T01:31:56.430Z",
      "response": {
        "UeTag": "UeTag_927455",
        "dispStr": "Menu Sent",
        "topic": "Has your issue been resolved?\nPlease respond with a number.",
        "delivered": "true",
        "delStatus": "delivered"
      },
      "requestId": "INC0010433"
    }
  ],
  "counts": 1,
  "totalRecords": 1,
  "lastRecordId": "57e87a8cb9ea8cec6afc7ce9"
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/uetags/UeTag_058297,UeTag_058298/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "filterCmd": "getSids"
}
{
    "result": [
        {
            "name": "",
            "date": "2021-05-15T00:45:08.977Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "918cc357-a80e-4d79-a62e-64ffad27d3f8-uxidxyz-7003a566-ad32-465f-ad53-8f0352967035"
        },
        {
            "name": "",
            "date": "2021-05-15T00:45:10.084Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "27eaed7c-8409-4ebc-9a5d-5682a8d074eb-uxidxyz-f797378f-9864-4b5e-a0d0-01ec05a912f6"
        },
        {
            "name": "",
            "date": "2021-05-15T00:45:11.046Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "de7c752a-cefe-47bd-917c-929c8e7915a3-uxidxyz-2451c596-7b37-4a96-a5fd-1633c317c5c8"
        }
    ],
    "counts": 3,
    "totalRecords": 3,
    "lastRecordId": "609f1997bd8c2573a6d9226b"
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/uetags/UeTag_058297,UeTag_058298/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "filterCmd": "getCounts"
}
{
    "UeTag": "UeTag_058297,UeTag_058298",
    "UeTag_058297": "3",
    "UeTag_058298": "0",
    "counts": 3
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/uetags/UeTag_058297,UeTag_058298/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "filterCmd": "getLastEngagement,getSids"
}
{
    "result": [
        {
            "name": "",
            "date": "2021-05-15T00:45:08.977Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "918cc357-a80e-4d79-a62e-64ffad27d3f8-uxidxyz-7003a566-ad32-465f-ad53-8f0352967035"
        },
        {
            "name": "",
            "date": "2021-05-15T00:45:10.084Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "27eaed7c-8409-4ebc-9a5d-5682a8d074eb-uxidxyz-f797378f-9864-4b5e-a0d0-01ec05a912f6"
        },
        {
            "name": "",
            "date": "2021-05-15T00:45:11.046Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "de7c752a-cefe-47bd-917c-929c8e7915a3-uxidxyz-2451c596-7b37-4a96-a5fd-1633c317c5c8"
        }
    ],
    "counts": 3,
    "totalRecords": 3,
    "lastRecordId": "609f1997bd8c2573a6d9226b"
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/uetags/UeTag_058297,UeTag_058298/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "filterCmd": "LastFirst,getSids"
}
{
    "result": [
        {
            "name": "",
            "date": "2021-05-15T00:45:11.046Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "de7c752a-cefe-47bd-917c-929c8e7915a3-uxidxyz-2451c596-7b37-4a96-a5fd-1633c317c5c8"
        },
        {
            "name": "",
            "date": "2021-05-15T00:45:10.084Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "27eaed7c-8409-4ebc-9a5d-5682a8d074eb-uxidxyz-f797378f-9864-4b5e-a0d0-01ec05a912f6"
        },
        {
            "name": "",
            "date": "2021-05-15T00:45:08.977Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "918cc357-a80e-4d79-a62e-64ffad27d3f8-uxidxyz-7003a566-ad32-465f-ad53-8f0352967035"
        }
    ],
    "counts": 3,
    "totalRecords": 3,
    "lastRecordId": "609f1994bd8c2573a6d92261"
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/uetags/UeTag_058297,UeTag_058298/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "filterCmd": "getSids,LastFirst,getRecordIds"
}
{
    "result": [
        {
            "name": "",
            "date": "2021-05-15T01:48:47.336Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "fa6bac68-6997-43c9-aea8-817761677338-uxidxyz-bde3af41-6093-4694-91fe-a29829351309",
            "ushurRecordId": "609f287fbd8c2573a6d9227a"
        },
        {
            "name": "",
            "date": "2021-05-15T01:48:46.593Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "d48cb507-e8fd-4a6e-96e3-a86ad43620b6-uxidxyz-f16b9941-54f5-40f4-bcb5-eade0c6054ac",
            "ushurRecordId": "609f287ebd8c2573a6d92275"
        },
        {
            "name": "",
            "date": "2021-05-15T01:48:45.239Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "false",
                "delStatus": "ToBeSentOut"
            },
            "requestId": "TEST_REQUEST_ID",
            "sid": "8c5a7f15-f405-4f3b-b55c-32762b7d46a4-uxidxyz-2702798e-d6f8-46cf-bbe4-8d8a1e61f36f",
            "ushurRecordId": "609f287dbd8c2573a6d92270"
        }
    ],
    "counts": 3,
    "totalRecords": 3,
    "lastRecordId": "609f287dbd8c2573a6d92270"
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/uetags/UeTag_058297,UeTag_058298/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "delivered": true
}
{
    "result": [
       {
            "name": "",
            "phone": "+1408XXXYYYY",
            "date": "2021-05-15T01:54:23.900Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "true",
                "delStatus": "delivered"
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "phone": "+14089178304",
            "date": "2021-05-15T01:54:24.605Z",
            "response": {
                "campaignId": "proxyTestUshur",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "delivered": "true",
                "delStatus": "delivered"
            },
            "requestId": "TEST_REQUEST_ID"
        }
    ],
    "counts": 2,
    "totalRecords": 2,
    "lastRecordId": "609f29d0bd8c2573a6d922a2"
}
Method: POST
URL: https://instance.ushur.me/api/rest/ushurs/proxyTestUshur/activities/search
Content-Type: application/json
Authorization: Bearer <TOKEN>

{
    "requestId": "TEST_REQUEST_ID",
    "filterCmd": "getSids,LastFirst"
}
{
    "stats": {
        "menu.sent": 0,
        "menu.resp": 0
    },
    "result": [
        {
            "name": "",
            "date": "2021-05-15T02:00:27.880Z",
            "sid": "6436cd3e-7249-493d-8b1a-1a2cd303c230-uxidxyz-36c03b49-6099-4c21-ae3d-fae25b0b2e59",
            "timestamp": "2021-05-15T02:00:27.880Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_**ENDCAMPAIGN**",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "ushur.end",
                "UeTag": "UeTag_End",
                "dispStr": "EndOfUshur",
                "meta": {
                    "menuOptions": {}
                }
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "date": "2021-05-15T02:00:27.874Z",
            "sid": "6436cd3e-7249-493d-8b1a-1a2cd303c230-uxidxyz-36c03b49-6099-4c21-ae3d-fae25b0b2e59",
            "timestamp": "2021-05-15T02:00:27.870Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_**ENDCAMPAIGN**",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "ushur.end",
                "UeTag": "UeTag_Primary_End",
                "dispStr": "EndOfWorkflow",
                "meta": {
                    "menuOptions": {}
                }
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "date": "2021-05-15T02:00:27.861Z",
            "sid": "6436cd3e-7249-493d-8b1a-1a2cd303c230-uxidxyz-36c03b49-6099-4c21-ae3d-fae25b0b2e59",
            "timestamp": "2021-05-15T02:00:27.856Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_section_e4306a9a-19aa-426a-89b8-1d9ac4b1ea07",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "menu.disabled.sent",
                "UeTag": "UeTag_308171",
                "dispStr": "Message Sent",
                "assetId": "",
                "content": "Thanks!",
                "sentOut": "no",
                "delivered": "false",
                "delStatus": "ToBeSentOut",
                "moduleType": "thankyou"
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "date": "2021-05-15T02:00:27.839Z",
            "sid": "6436cd3e-7249-493d-8b1a-1a2cd303c230-uxidxyz-36c03b49-6099-4c21-ae3d-fae25b0b2e59",
            "timestamp": "2021-05-15T02:00:27.833Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur_child_section_8335106c-59ab-4951-a1cd-c8b29c063f99",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "menu.disabled.sent",
                "UeTag": "UeTag_887451",
                "dispStr": "Message Sent",
                "assetId": "",
                "content": "message1 null",
                "sentOut": "no",
                "delivered": "false",
                "delStatus": "ToBeSentOut",
                "moduleType": "promptmessage"
            },
            "requestId": "TEST_REQUEST_ID"
        },
        {
            "name": "",
            "date": "2021-05-15T02:00:27.815Z",
            "sid": "6436cd3e-7249-493d-8b1a-1a2cd303c230-uxidxyz-36c03b49-6099-4c21-ae3d-fae25b0b2e59",
            "timestamp": "2021-05-15T02:00:27.813Z",
            "location": "",
            "response": {
                "menuId": "proxyTestUshur",
                "campaignId": "proxyTestUshur",
                "visual": "false",
                "type": "menu.disabled.sent",
                "UeTag": "UeTag_058297",
                "dispStr": "Message Sent",
                "content": "[mayank]:",
                "origUserMsg": "[mayank]:null",
                "UeTagStart": "UeTag_Start",
                "sentOut": "no",
                "delivered": "false",
                "delStatus": "ToBeSentOut",
                "virtualNo": "12762402315"
            },
            "requestId": "TEST_REQUEST_ID"
        }
    ],
    "counts": 5,
    "totalRecords": 5
}

Get All Detailed Responses

This query will fetch all responses without any filters and with many details. Such queries are provided so that enterprises can design their own applications accordingly or adopt any of these Ushur APIs to fit their existing applications. It is important to note that such queries can be expensive and generally used for report creation purposes.

Parameter Description
tokenId The credential for identifying the account. This is the tokenId that was sent by Ushur as part of the login response.
startDate The date of the request sent or responses received.
endDate The ending date for which responses are to be retrieved.
userPhoneNo This is an optional parameter. If this is not sent then all engagements are retrieved for this account indicated by the tokenId. If this parameter is passed then the engagements with this specific phone number are retrieved. The startDate, endDate, and userPhoneNo can be combined in all the other discussed requests here.
Method: POST
URL: https://community.ushur.me/infoQuery
Content-Type: application/json

{
"tokenId":"{{token}}",
"startDate":"2016-02-02T12:26:12.791Z",
"endDate":"2016-02-28T12:26:12.791Z",
"userPhoneNo":"14088987788"
}
{
    "result": [
        {
            "date": "Tue Mar 10 00:50:51 EDT 2015",
            "location": "",
            "name": "Henry G",
            "phone": "+12098746734",
            "response": {
                "content": "[Ushur]:hi henry how are you?",
                "dispStr": "Message Sent",
                "menuId": "",
                "type": "menu.disabled.sent"
            },
            "sid": "ec7bb83a-79ff-4c3d-939d-0ab0391d4b6f-uxidxyz-a418bf65-41aa-4171-a951-93d82eb7cda8",
            "timestamp": "Tue Mar 10 00:50:51 EDT 2015"
        },
        {
            "date": "Tue Mar 10 00:51:00 EDT 2015",
            "location": "",
            "name": "Henry G",
            "phone": "+12098746734",
            "response": {
                "content": "[Henry]:got this now",
                "dispStr": "got this now",
                "menuId": "",
                "type": "menu.disabled.response"
            },
            "sid": "ec7bb83a-79ff-4c3d-939d-0ab0391d4b6f-uxidxyz-a418bf65-41aa-4171-a951-93d82eb7cda8",
            "timestamp": "Tue Mar 10 00:51:00 EDT 2015"
        },
        {
            "date": "Mon Mar 30 23:41:02 EDT 2015",
            "location": "",
            "name": "",
            "phone": "+12098746734",
            "response": {
                "content": "[Ushur]:msg only on 033015 tested Now_0",
                "dispStr": "Message Sent",
                "menuId": "",
                "type": "menu.disabled.sent"
            },
            "sid": "233a3748-1b46-4c2a-9df5-1cf97c582a90-uxidxyz-02611318-d445-4393-86e9-feb77ca7dbdd",
            "timestamp": "Mon Mar 30 23:41:02 EDT 2015"
        },
        {
            "date": "Mon Mar 30 23:41:02 EDT 2015",
            "location": "",
            "name": "",
            "phone": "+12098746734",
            "response": {
                "content": "[Ushur]:msg only on 033015 tested Now_1",
                "dispStr": "Message Sent",
                "menuId": "",
                "type": "menu.disabled.sent"
            },
            "sid": "c918cb3f-5275-42c0-ae7e-3265623c5f17-uxidxyz-389f5d1e-2e0b-4e27-9e35-cfbd7e14b0a4",
            "timestamp": "Mon Mar 30 23:41:02 EDT 2015"
        },
        {
            "date": "Mon Mar 30 23:41:03 EDT 2015",
            "location": "",
            "name": "",
            "phone": "+12098746734",
            "response": {
                "content": "[Ushur]:msg only on 033015 tested Now_2",
                "dispStr": "Message Sent",
                "menuId": "",
                "type": "menu.disabled.sent"
            },
            "sid": "9ca7121f-987e-4570-b5f5-d58df99cb315-uxidxyz-54ab3ed3-883b-4383-a6a4-cd82e49294be",
            "timestamp": "Mon Mar 30 23:41:03 EDT 2015"
        },
        {
            "date": "Mon Mar 30 23:50:17 EDT 2015",
            "location": "",
            "name": "Henry G",
            "phone": "+12098746734",
            "response": {
                "content": "[Ushur]:hi henry there",
                "dispStr": "Message Sent",
                "menuId": "",
                "type": "menu.disabled.sent"
            },
[...]
